SystemOrganization addCategory: #'CS528su13AES-HW3'!

Number subclass: #NumberWithUnits
	instanceVariableNames: 'value units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW3'!

!NumberWithUnits class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/11/2013 15:57'!
value: aNumber unit: aUnit
	^self new value: aNumber unit: aUnit.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/12/2013 11:58'!
* aValue
	value := value * aValue value.
	units := units multiplyUnits: aValue units.
	^self.
	! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/14/2013 19:15'!
+ aValue
	units = aValue units  ifTrue: [ 
	value := value + aValue value].
	^self.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/14/2013 19:16'!
- aValue
	units = aValue units  ifTrue:[ 
	value := value - aValue value].
	^self.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/12/2013 11:57'!
/ aValue 
	value := value / aValue  value.
	units := units divideUnits: aValue units.
	^self.! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/14/2013 19:16'!
< aValue
"provided units are the same"
	units = aValue units 
	ifTrue:[
		^(value < aValue value)]
	ifFalse:[
		^false
	] ! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/14/2013 19:14'!
= aValue
	(value = aValue value) ifTrue: [ 
		(units = aValue units) ifTrue: [ ^true ]
		 ] .
	 ^false. ! !

!NumberWithUnits methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/11/2013 15:49'!
adaptToFraction: rcvr andSend: selector! !

!NumberWithUnits methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/11/2013 15:50'!
adaptToInteger: rcvr andSend: selector! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/11/2013 15:55'!
hash! !

!NumberWithUnits methodsFor: 'testing' stamp: 'ShruthiSudhanva 6/14/2013 19:08'!
isNumberWithUnits
	^true.! !

!NumberWithUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/14/2013 19:20'!
printOn: aStream base: base

	value printOn: aStream base: base.
	aStream nextPut: Character space.
	units printOn: aStream .
! !

!NumberWithUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/11/2013 15:56'!
storeOn: arg1 base: arg2! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/11/2013 21:11'!
units
	^units! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/12/2013 11:54'!
value
	^value ! !

!NumberWithUnits methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/14/2013 19:12'!
value: aValue unit: aUnit
	super initialize.
	units := Units new.
	units add: aUnit.
	
	(aValue isNumberWithUnits) ifTrue: [
		value := aValue value.
		units := units multiplyUnits: aValue units.
		]
	ifFalse:[
	value := aValue].

	^self.
! !

Object subclass: #Units
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW3'!

!Units methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/12/2013 11:59'!
= aUnit 
	^dict = aUnit dict! !

!Units methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/12/2013 22:24'!
add: aUnit
	self dict at: aUnit put: 1.! !

!Units methodsFor: 'private' stamp: 'ShruthiSudhanva 6/14/2013 17:58'!
at: symbol
	(dict includesKey:symbol) ifTrue: [^dict at:symbol ] ifFalse:[^0].! !

!Units methodsFor: 'private' stamp: 'ShruthiSudhanva 6/14/2013 18:09'!
at: symbol put: value 
	dict at:symbol put:value! !

!Units methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/11/2013 20:57'!
dict
	^dict.! !

!Units methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/14/2013 18:13'!
divideUnits: aUnit
	| allSymbols resultUnit|
	allSymbols := Set newFrom: (self dict keys , aUnit dict keys ).
	resultUnit := Units new.
	allSymbols do:[:symbol | resultUnit at:symbol put: (self at:symbol) - (aUnit at:symbol)].
	
	^resultUnit.
	
	"aDictionary  keysAndValuesDo: [:key :value |
		(dict includesKey: key) ifTrue: [  
		dict at: key put: (dict  at:key) - value ]
		ifFalse:[
			dict at:key put: 0-value
			]
		].
	^self."! !

!Units methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/11/2013 17:31'!
hash! !

!Units methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/11/2013 21:01'!
initialize 
	super initialize.
	dict := Dictionary new.
	^self.! !

!Units methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/14/2013 18:12'!
multiplyUnits: aUnit
	| allSymbols resultUnit|
	allSymbols := Set newFrom: (self dict keys , aUnit dict keys ).
	resultUnit := Units new.
	allSymbols do:[:symbol | resultUnit at:symbol put: (self at:symbol) + (aUnit at:symbol)].
	
	^resultUnit.! !

!Units methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/14/2013 18:44'!
printOn: aStream
"Try coverting them into a set and then select on it. Easier"

	| numerator denominator |
	
	numerator := dict associationsSelect: [ :assoc | assoc value >0 ].
	numerator keysAndValuesDo: [:key :value | self printOn: aStream times: value key: key ].

	
	denominator := dict associationsSelect: [ :assoc | assoc value <0 ].
	denominator ifNotEmpty:[aStream nextPut: $/].
	denominator keysAndValuesDo: [:key :value | self printOn: aStream times: 0-value key: key ].
	
	
	"
	dict keysAndValuesDo: [ :key :value | (value > 0)
				 ifTrue: [ self printOn: aStream times: value key: key 
					 ]].
			
	dict keysAndValuesDo: [ :key :value | (value < 0)
				ifTrue: [ aStream nextPut:$/.
					 self printOn: aStream times:( 0-value) key: key ]
				 ]."
! !

!Units methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/14/2013 18:21'!
printOn: aStream times: aValue key: aKey 
	aValue timesRepeat: [
						(aKey as:String) printOn: aStream. 
						aStream nextPut: Character space.]! !

TestCase subclass: #HW3Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW3'!

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:28'!
testNumberWithUnitsAddNumbers
	| stream |
	stream := String new writeStream.
	(4 sec sec + 10.5 sec sec)  printOn: stream.
	self assert:  stream contents = '14.5 ''seconds'' ''seconds'' '.! !

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 12:11'!
testNumberWithUnitsCompareNumbers
	| stream |
	stream := String new writeStream.
	(3 sec = 3 sec) printOn: stream.
	self assert: stream contents = 'true'.
	stream reset.
	(5 elephants = 3 sec) printOn: stream.
	self assert: stream contents = 'false'.
	stream reset.
	(4 meters < 5 meters) printOn: stream.
	self assert: stream contents = 'true'.
	stream reset.
	(4 meters > 5 meters) printOn: stream.
	self assert: stream contents = 'false'.! !

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:35'!
testNumberWithUnitsDivideNumbers
	| stream |
	stream := String new writeStream.
	(8 sec elephants / 4 sec meters)  printOn: stream.
	self assert: stream contents = '2 ''elephants'' /''meters'' '.
	stream reset.
	(4 sec * 3 meters / 4 sec meters) printOn: stream.
	self assert: stream contents = '3 '.! !

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:30'!
testNumberWithUnitsMultiplyNumbers
	| stream |
	stream := String new writeStream.
	(4 sec elephants * 10.5 sec meters)  printOn: stream.
	self assert: stream contents =  '42.0 ''elephants'' ''seconds'' ''seconds'' ''meters'' '.! !

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/13/2013 12:37'!
testNumberWithUnitsSingleUnit
	| stream |
	stream := String new writeStream.
	3 sec printOn: stream.
	self assert:  stream contents = '3 ''seconds'' '.! !

!HW3Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:28'!
testNumberWithUnitsSubtractNumbers
	| stream |
	stream := String new writeStream.
	(4 sec meters - 10.5 sec meters)  printOn: stream.
	self assert: stream contents = '-6.5 ''seconds'' ''meters'' '.! !
